var ExamsTutorDevicePlugin = (function() {
    var a = ExamsTutorAndroidPlugin;
    function parseJSON(json) {
    	var data = null;
    	try {
    		data = $.parseJSON(json);
    	} catch(e) {
    		data = null;
    	}
    	return data;
    }
    var savedCallback;
    return {
        cancelledPathwaySelection: function() { a.cancelledPathwaySelection() },
        performCallback: function() {
            if( savedCallback ) {
                savedCallback( a.callbackResult() );
            }
        },
        prepareHTML: function(html) {return String(a.prepareHTML(html)); },
        log: function(message) { a.log(message); },
        requiresInitialPathway: function() { return a.requiresInitialPathway(); },
        showPathwayDialog: function() { a.showPathwayDialog() },
        currentPage: function(page) { return a.currentPage(page) },
        requiresLogin: function() { return a.requiresLogin() },
        login: function(username, password, callbackFailed) {
            savedCallback = function(ret) { callbackFailed(Number(String(ret))); };
            a.login(username, password); },
        showPage: function(page) { a.showPage(page) },
        defaultPathway: function() { return parseJSON(String(a.defaultPathway())) },
        setDefaultPathway: function(pathway) { a.setDefaultPathway($.toJSON(pathway)) },
        activeSubject: function() { return a.activeSubject() },
        activeTest: function() { return parseJSON(String(a.activeTest())) },
        setAppProperties: function(appProperties) {  },
        loginPathway: function() { return parseJSON(String(a.loginPathway())) },
        clearLoginPathway: function() { a.clearLoginPathway() },
        loadPathways: function(callback) {
            setTimeout( function() {
                callback(parseJSON(String(a.loadPathways())));
            }, 5 ); },
        updateTestModules: function(callback) { setTimeout( function() {
                a.updateTestModules();
                callback();
            }, 5 ); },
        alert: function(message, callback) {
            savedCallback = callback;
            a.alert(message) },
        confirm: function(message, callback) {
            savedCallback = function(val) { callback(val == "true") }; 
            a.confirm(message); },
        downloadPathway: function(pathway_ref, callback) { setTimeout( function() {
                callback(parseJSON(String(a.downloadPathway(pathway_ref))));
            }, 5 ); },
        getTestModules: function() { return parseJSON(String(a.getTestModules())) },
        setActiveTest: function(test) { a.setActiveTest($.toJSON(test)) },
        savePreviousQuestionResult: function(testRef, questionNumber, correct) { a.savePreviousQuestionResult(testRef,questionNumber,correct) },
        previousQuestionResult: function(testRef, questionNumber) {
        	var val =  a.previousQuestionResult(testRef,questionNumber);
        	return val == "true" ? true : ( val == "false" ? false : null ) },
        saveTestResult: function(test) { a.saveTestResult($.toJSON(test)) },
        reportCardEntryForTest: function(testRef) { return parseJSON(String(a.reportCardEntryForTest(testRef))) },
        getAppProperty: function(name) { return parseJSON(String(a.getAppProperty(name))); },
        showRandomTestChoice: function(unit_ref) { a.showRandomTestChoice(unit_ref) },
        randomTestUnit: function() { return a.randomTestUnit() },
        demoMode: function() { return a.demoMode() == "true"; },
        lastLoginUsername: function() { return String(a.lastLoginUsername()); },
        lastLoginPassword: function() { return String(a.lastLoginPassword()); },
        enterStudyRoom: function() { a.enterStudyRoom(); },
        requestStudyRoomDetails: function() { a.requestStudyRoomDetails() },
        1:1 // making sure the last entry has no comma
    }
})();
