var ExamsTutorDevicePlugin = (function() {
    //var base = 'https://www.examstutor.com/a/';
    var base = '../../../proxy.php/';
    var key = '53$ErfeTR$746vef540967HvX3$j9';
    var properties = {};
    var lastLoginPasswordValue = '';

    function xhr( url, callback, method, postData ) {
        var request = new XMLHttpRequest();
        if( ! method )
            method = 'GET';
        request.open(method, base + url, true);
        request.onreadystatechange = function() {
            if( request.readyState == 4 ) {
                callback(request);
            }
        }
        request.send(postData);
    }

    function xhrJSON( url, callback, method, postData ) {
        xhr(url, function(request) {
            if( request.status == 200 ) {
                callback( parseJSON(request.responseText) );
            } else {
                callback( null );
            }
        }, method, postData );
    }

    function prepareHTML(html) {
        return html.replace(/src="\//, "src=\"http://www.examstutor.com/");
    }

    function parseJSON(str) {
        try {
            return $.parseJSON(str);
        } catch(e) {
        }
        return null;
    }

    function requiresInitialPathway() {
        return !(defaultPathway() || localStorage['examstutor.cancelledPathwayChoice']);
    }

    function showPathwayDialog() {
        if( requiresLogin() ) {
            showPage('login.html');
        } else {
            showPage('select-pathway.html');
        }
    }

    function currentPage(page) {
        var matches = location.toString().match(/\/([^\/]+)$/);
        if( matches ) {
            var currentPage = matches[1].replace(/\?.*$/,'');
            if( page == currentPage ) {
                return true;
            }
        }
        return false;
    }

    function requiresLogin() {
        return properties['requires_login'] != false;
    }

    function login(username, password, callbackFailed) {
        localStorage['examstutor.lastLoginUsername'] = username;
        var url = 'api_revisionpathway.php?validrequest_sent='+key+
                '&username_sent='+encodeURIComponent(username)+'&password_sent='+encodeURIComponent(password)+'&subjectid_sent='+activeSubject();
        xhr(url, function(request) {
            var response = $.parseJSON(request.responseText);
            if( request.status == 200 && response) {
                localStorage['examstutor.loginPathway'] = $.toJSON(response);
                updateTestModules(function() {
                    showPage('select-pathway.html');
                });
            } else {
                callbackFailed(request.status);
            }
        });
    }

    function loginPathway() {
        return $.parseJSON(localStorage['examstutor.loginPathway']);
    }

    function clearLoginPathway() {
        localStorage['examstutor.loginPathway'] = null;
    }

    function showPage(page) {
        var url = window.location.toString().replace(/\/([^\/]+)$/, '');
        url += '/'+page;
        window.location = url;
    }

    function defaultPathway() {
        return $.parseJSON(localStorage['examstutor.lastSelectedRevisionPathway.'+activeSubject()]);
    }

    function setDefaultPathway(pathway) {
        localStorage['examstutor.lastSelectedRevisionPathway.'+activeSubject()] = $.toJSON(pathway);
    }

    function activeSubject() {
        return properties.subject_ref;
    }

    function activeTest() {
        return $.parseJSON(localStorage['examstutor.activeTest.'+activeSubject()]);
    }

    function setActiveTest(test) {
        localStorage['examstutor.activeTest.'+activeSubject()] = $.toJSON(test);
    }

    function setAppProperties(appProperties) {
        if( appProperties ) {
            properties = appProperties;
        } else {
            properties = {};
        }
    }

    function loadPathways( callback ) {
        var url = 'api_paths.php?validrequest_sent='+key+'&subjectid_sent='+activeSubject();
        xhrJSON(url, callback);
    }

    function updateTestModules( callback ) {
        var url = 'api_tests.php?validrequest_sent='+key+'&subjectid_sent='+activeSubject();
        xhrJSON(url, function( response ) {
            if( response ) {
                localStorage['examstutor.testModules.'+activeSubject()] = $.toJSON(response);
            }
            callback();
        });
    }

    function getTestModules() {
        return $.parseJSON(localStorage['examstutor.testModules.'+activeSubject()]);
    }

    function alert(message, callback) {
        window.alert(ExamsTutor._(message));
        if( callback ) {
            setTimeout( function() {
                callback();
            }, 5 );
        }
    }
    function confirm(message, callback) {
        setTimeout( function() {
         callback(window.confirm(message));
        }, 5 );
    }
    
    function downloadPathway(pathway_ref, callback) {
        var url = 'api_revisionpathway.php?validrequest_sent='+key+'&path_sent='+pathway_ref+'&subjectid_sent='+activeSubject();
        xhrJSON(url, function( response ) {
            if( response ) {
                callback(response);
            } else {
                callback(null);
            }
        });
    }

    function savePreviousQuestionResult(testRef, questionNumber, correct) {
        var previousQuestionResults = $.parseJSON(localStorage['examstutor.previousQuestionResults.'+activeSubject()]);
        if(!previousQuestionResults) {
            previousQuestionResults = {};
        }
        previousQuestionResults[testRef+'-'+questionNumber] = correct;
        localStorage['examstutor.previousQuestionResults.'+activeSubject()] = $.toJSON(previousQuestionResults);
    }

    function previousQuestionResult(testRef, questionNumber) {
        var previousQuestionResults = $.parseJSON(localStorage['examstutor.previousQuestionResults.'+activeSubject()]);
        if(previousQuestionResults) {
            return previousQuestionResults[testRef+'-'+questionNumber];
        }
        return null;
    }

    function saveTestResult(test) {
        if( ! test['properties'] )
            return;

        var testRef = test['properties']['ref'];
        var score = test['currentScore'];
        var maxScore = test['currentMaxScore'];
        var reportCardEntries = $.parseJSON(localStorage['examstutor.reportCardEntries.'+activeSubject()]);
        if( ! reportCardEntries ) {
            reportCardEntries = {};
        }
        var reportCardEntry = reportCardEntries[testRef];
        while(reportCardEntry && reportCardEntry['results'].length > 10) {
            reportCardEntry['results'].shift();
        }
        if(!reportCardEntry) {
            reportCardEntry = {
                results: [],
                avgScore: 0,
                highestScore: 0,
                lastScore: 0,
                numAttempts: 0 };
            reportCardEntries[testRef] = reportCardEntry;
        }
        reportCardEntry['avgScore'] = ( score + ( reportCardEntry['avgScore'] * reportCardEntry['numAttempts'] ) ) / ( reportCardEntry['numAttempts'] + 1 );
        reportCardEntry['highestScore'] = Math.max(reportCardEntry['highestScore'], score);
        reportCardEntry['lastScore'] = score;
        reportCardEntry['numAttempts'] ++;
        reportCardEntry['results'].push({
            maxScore: maxScore,
            score: score
        });
        localStorage['examstutor.reportCardEntries.'+activeSubject()] = $.toJSON(reportCardEntries);
    }

    function reportCardEntryForTest(testRef) {
        testRef = String(testRef);
        var reportCardEntries = $.parseJSON(localStorage['examstutor.reportCardEntries.'+activeSubject()]);
        if( reportCardEntries ) {
            return reportCardEntries[testRef];
        }
        return;
    }

    function getAppProperty(name) {
        return properties[name];
    }

    function showRandomTestChoice(unit_ref) {
        ExamsTutor.showPage('choose-random-test.html?from_unit='+unit_ref);
    }

    function randomTestUnit() {
        return $.url.param('from_unit');
    }

    function demoMode() {
        return false;
    }

    function log() {
        if( window.console && window.console.log ) {
            window.console.log.apply( window.console, arguments );
        }
    }

    function cancelledPathwaySelection() {
        localStorage['examstutor.cancelledPathwayChoice'] = 'true';
    }

    function lastLoginUsername() {
        var username = localStorage['examstutor.lastLoginUsername'];
        if( ! username )
            username = '';
        return username;
    }

    // No secure place to store this so we don't
    function lastLoginPassword() {
        return lastLoginPasswordValue;
    }

    function requestStudyRoomDetails() {
        var udid = localStorage['examstutor.udid'];
        if (!udid) {
            udid = Math.random().toString();
            localStorage['examstutor.udid'] = udid;
        }
        var url = sprintf("api_applecollege.php?validrequest_sent=%@&subjectid_sent=%@&instituteid=49437&appid=%@",
            key,
            ExamsTutor.activeSubject(),
            udid);
        xhr(url, function(request) {
            var response = $.parseJSON(request.responseText);
            if (request.status == 200 && response) {
                localStorage['examstutor.lastLoginUsername'] = response['username'];
                lastLoginPasswordValue = response['Password'];
                enterStudyRoom();
            } else {
                callbackFailed(request.status);
            }
        });
    }

    function enterStudyRoom() {
        var url_format = ExamsTutor.getAppProperty('studyroom_login_url');
        var url = sprintf(url_format, ExamsTutor.lastLoginUsername(), ExamsTutor.lastLoginPassword());
        document.location = url;
    }

    return {
        cancelledPathwaySelection: cancelledPathwaySelection,
        requiresInitialPathway: requiresInitialPathway,
        showPathwayDialog: showPathwayDialog,
        currentPage: currentPage,
        requiresLogin: requiresLogin,
        login: login,
        showPage: showPage,
        defaultPathway: defaultPathway,
        setDefaultPathway: setDefaultPathway,
        activeSubject: activeSubject,
        activeTest: activeTest,
        setAppProperties: setAppProperties,
        loginPathway: loginPathway,
        clearLoginPathway: clearLoginPathway,
        loadPathways: loadPathways,
        updateTestModules: updateTestModules,
        alert: alert,
        confirm: confirm,
        downloadPathway: downloadPathway,
        getTestModules: getTestModules,
        setActiveTest: setActiveTest,
        savePreviousQuestionResult: savePreviousQuestionResult,
        previousQuestionResult: previousQuestionResult,
        saveTestResult: saveTestResult,
        reportCardEntryForTest: reportCardEntryForTest,
        getAppProperty: getAppProperty,
        showRandomTestChoice: showRandomTestChoice,
        randomTestUnit: randomTestUnit,
        prepareHTML: prepareHTML,
        demoMode: demoMode,
        log: log,
        lastLoginUsername: lastLoginUsername,
        lastLoginPassword: lastLoginPassword,
        enterStudyRoom: enterStudyRoom,
        requestStudyRoomDetails: requestStudyRoomDetails,
        1:1 // making sure the last entry has no comma
    }
})();
